__package__    = "aws.py"
__version__    = "1.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/growler/"
__cvsversion__ = "$Revision: 1.2 $"
__date__       = "$Date: 2008/01/04 06:23:46 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

from boto.s3.connection import S3Connection
from boto.s3.key import Key

import mem

class s3 (mem.cache) :

    def __init__ (self, key, secret, bucket_name) :

        mem.cache.__init__(self)
        
        self.access_key = key
        self.secret_key = secret
        self.bucket_name = bucket_name
        
        self.conn = None
        self.bucket = None

    #
    
    def open (self) :
        
        bucket_name = "info.aaronland.%s" % self.bucket_name
        
        conn = S3Connection(self.access_key, self.secret_key)

        res = conn.get_all_buckets()
        bucket = None

        for item in res :            
            if item.name == bucket_name :
                bucket = item
                break

        if not bucket :
            bucket = conn.create_bucket(bucket_name)
            bucket.set_acl('private')

        self.conn = conn
        self.bucket = bucket

        return True
    
    #

    def close (self) :
        pass
    
    #
    
    def read (self, key) :

        cache = self.get_mem_cache(key)

        if cache :
            return cache
        
        s3 = Key(self.bucket)
        s3.key = key

        if s3.exists() : 
            return s3.get_contents_as_string()
        
    #
    
    def write (self, key, value) :

        s3 = Key(self.bucket)
        s3.key = key

        s3.set_contents_from_string(value)
        self.set_mem_cache(key, value)
        # print s3.generate_url(300)

    #

    def delete (self, key) :

        s3 = Key(self.bucket)
        s3.key = key

        if s3.exists() :
            s3.delete()
            
    #
    
    def uri (self, key) :

        s3 = Key(self.bucket)
        s3.key = key

        if s3.exists() :
            return self.generate_url(60)
                
if __name__ == '__main__' : 

    import time
    
    bucket = 'flactivity'

    key = '00VSSB50FKX81YD4YN82'
    secret = 'mJ5l9d6/JW3Rhd7re8R8dlxyocZR9IflsYF5FAoc'
    
    store = s3(key, secret, bucket)
    store.open()

    print store.read('debug')
    print store.read('spork')
    
    store.write('debug', time.time())
    print store.read('debug')

    print store.read('debug')    

    store.delete('debug')
    print store.read('debug')    
